package example.org.cuentanos;

import android.content.Context;
import android.content.res.Resources;
import android.database.Cursor;
import android.graphics.drawable.Drawable;
import android.support.v4.widget.CursorAdapter;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

/**
 * Created by Jota on 14/11/2015.
 */
public class AdaptadorCursorBusquedas extends CursorAdapter {
    private LayoutInflater inflador;
    ImageView state;
    TextView fecha;
    ImageView foto;

    public AdaptadorCursorBusquedas(Context contexto, Cursor c) {
        super(contexto, c, false);
    }

    @Override
    public View newView(Context contexto, Cursor c, ViewGroup padre) {
        inflador = (LayoutInflater) contexto
                .getSystemService(Context.LAYOUT_INFLATER_SERVICE);

        return inflador.inflate(R.layout.elemento_busqueda, padre, false);
    }

    @Override
    public void bindView(View vista, Context contexto, Cursor c) {

        fecha = (TextView) vista.findViewById(R.id.fecha);
        foto = (ImageView) vista.findViewById(R.id.foto);
        state = (ImageView) vista.findViewById(R.id.foto2);



        fecha.setText((c.getString(c.getColumnIndex("fecha"))).trim());



        Resources res = contexto.getResources();
        String mDrawableName = c.getString(c.getColumnIndex("imagen"));
        int resID = res.getIdentifier(mDrawableName, "drawable", contexto.getPackageName());
        Drawable drawable = res.getDrawable(resID);
        foto.setImageDrawable(drawable);


        int bEnviado=c.getInt(c.getColumnIndex("enviado"));


        if(bEnviado==0)
        {

            resID=R.drawable.nosynch;

        }
        else {
            int bProcesado = c.getInt(c.getColumnIndex("procesado"));


            if (bProcesado == 0) {
                resID=R.drawable.sent;

            } else {
                resID=R.drawable.ok;

            }
        }
        // resID = res.getIdentifier(mDrawableName, "drawable", contexto.getPackageName());
         drawable = res.getDrawable(resID);
        state.setImageDrawable(drawable);


    }
}