package example.org.cuentanos;

import android.content.Context;
import android.database.Cursor;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.provider.MediaStore;
import android.support.v4.content.CursorLoader;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

/**
 * Created by Jota on 04/11/2015.
 */
public  class AppUtils {

    //obtiene el idioma
     public static String GetLanguage()
    {
        String pLanguage= Locale.getDefault().getLanguage();
        String result="";
        switch (pLanguage)
        {
            case "es":
                result="es";
                break;
            default:
                result="en";

        }
        return result;
    }

    //obtiene el path de una uri de una foto
    public static String getRealPathFromURI(Uri contentUri, Context mContext) {
        String[] proj = { MediaStore.Images.Media.DATA };
        CursorLoader loader = new CursorLoader(mContext, contentUri, proj, null, null, null);
        Cursor cursor = loader.loadInBackground();
        int column_index = cursor.getColumnIndexOrThrow(MediaStore.Images.Media.DATA);
        cursor.moveToFirst();
        String result = cursor.getString(column_index);
        cursor.close();
        return result;
    }

    //obtiene la fecha actual con formato par anombre fichero
    public static String FechaActualFile()
    {
        SimpleDateFormat sdf = new SimpleDateFormat("ddMMyyyy_HHmmss");

        return sdf.format(new Date());
    }


    //obtiene la fecha actual
    public static String FechaActual()
    {
        SimpleDateFormat sdf = new SimpleDateFormat();

        return  sdf.format(new Date());
    }




        //devuelve si hay internet
        public static boolean isConnectingToInternet(Context _context){
            ConnectivityManager connectivity = (ConnectivityManager) _context.getSystemService(Context.CONNECTIVITY_SERVICE);
            if (connectivity != null)
            {
                NetworkInfo[] info = connectivity.getAllNetworkInfo();
                if (info != null)
                    for (int i = 0; i < info.length; i++)
                        if (info[i].getState() == NetworkInfo.State.CONNECTED)
                        {
                            return true;
                        }

            }
            return false;
        }


    //devuelve si esta´s conectado por wifi
    public static boolean isConnectingByWiFi(Context _context) {
    boolean result=false;

        ConnectivityManager cm = (ConnectivityManager) _context.getSystemService(Context.CONNECTIVITY_SERVICE);
        if(cm!=null)
        {
            NetworkInfo wifi = cm.getNetworkInfo(ConnectivityManager.TYPE_WIFI);
            if(wifi!=null)
            {
                result=wifi.isConnected();
            }
        }
        return result;
    }



}
