

package example.org.cuentanos;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;


public class MainActivity extends Activity {
ImageView bttAux;

SharedPreferences pref;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);


        ControlaPrimeraEjecucion();
        if(!SynchService.IsRunning(this))
        {SynchAlarm.ConfiguraServicioAlarmas(this);}

        EnlazaEventos();
        InicializaBD();

    }


    //lanza las preferencias nada más empezar
    private void ControlaPrimeraEjecucion()
    {

        pref = PreferenceManager
                .getDefaultSharedPreferences(this);
        boolean flag = pref.getBoolean("firstTimeRun", true);




        //es la primera vez
        if (flag) {

            final CharSequence[] options = {
                    getResources().getText(R.string.Close)};
            final AlertDialog.Builder builder = new AlertDialog.Builder(MainActivity.this);
            builder.setTitle(getResources().getText(R.string.Firstime));
            builder.setCancelable(false);
            builder.setItems(options, new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int seleccion) {
                    if (options[seleccion] == getResources().getText(R.string.Close)) {
                        dialog.dismiss();
                        startActivity(new Intent(getBaseContext(), Preferencias.class));
                        SharedPreferences.Editor editor = pref.edit();
                        // la segunda vez ya no lo lanzará
                        editor.putBoolean("firstTimeRun", false);
                        editor.commit();
                    }
                }
            });





            builder.show();


        }


    }

private void InicializaBD()
{
    db_DataAcces odb_DataAcces=new db_DataAcces();
    odb_DataAcces.indicializaBD(this);
    odb_DataAcces.CierraBBDD();


}



    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.

        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            lanzarPreferencias(null);
            return true;
        }
        if (id == R.id.About) {
            lanzarAcercaDe(null);
            return true;
        }

        return super.onOptionsItemSelected(item);
    }


    private void EnlazaEventos()
    {
        TextView txtAux;
        LinearLayout layAux;
        //listener de nuevo
        bttAux =(ImageView) findViewById(R.id.bttAdd);
        bttAux.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                lanzarNuevo(null);
            }
        });

        txtAux =(TextView) findViewById(R.id.txtAdd);
        txtAux.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                lanzarNuevo(null);
            }
        });
        layAux =(LinearLayout) findViewById(R.id.layAdd);
        layAux.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                lanzarNuevo(null);
            }
        });


        //listener de about
        bttAux=(ImageView) findViewById(R.id.bttAbout);
        bttAux.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                lanzarAcercaDe(null);
            }
        });

        txtAux =(TextView) findViewById(R.id.txtAbout);
        txtAux.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                lanzarAcercaDe(null);
            }
        });
        layAux =(LinearLayout) findViewById(R.id.layAbout);
        layAux.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                lanzarAcercaDe(null);
            }
        });



        //listener de configuracion
        bttAux=(ImageView) findViewById(R.id.bttSetting);
        bttAux.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                lanzarPreferencias(null);
            }
        });
        txtAux =(TextView) findViewById(R.id.txtSett);
        txtAux.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                lanzarPreferencias(null);
            }
        });
        layAux =(LinearLayout) findViewById(R.id.laySett);
        layAux.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                lanzarPreferencias(null);
            }
        });



        //listener de synch
        bttAux=(ImageView) findViewById(R.id.bttSynch);
        bttAux.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                lanzarSynch(null);
            }
        });
        txtAux =(TextView) findViewById(R.id.txtSync);
        txtAux.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                lanzarSynch(null);
            }
        });
        layAux =(LinearLayout) findViewById(R.id.laySync);
        layAux.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                lanzarSynch(null);
            }
        });



        //listener de configuracion
        bttAux=(ImageView) findViewById(R.id.bttSearch);
        bttAux.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                lanzarBusqueda(null);
            }
        });
        txtAux =(TextView) findViewById(R.id.txtSear);
        txtAux.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                lanzarBusqueda(null);
            }
        });
        layAux =(LinearLayout) findViewById(R.id.laySear);
        layAux.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                lanzarBusqueda(null);
            }
        });



    }





    private void lanzarAcercaDe(View view){
        Intent i = new Intent(this, acercaDe.class);
        startActivity(i);
    }
    private void lanzarPreferencias(View view){
        Intent i = new Intent(this, Preferencias.class);
        startActivity(i);
    }

    public void lanzarNuevo(View view) {
       Intent i = new Intent(this, categoriaLista.class);
       startActivity(i);
    }

    public void lanzarSynch(View view) {


//// TODO: 13/11/2015 falta progressbar 

        InfoSync oInfo;
        oInfo=SynchManager.Synch(this);
        if(oInfo.isbOk()) {
            Notificacion.CreaciónNotificacion(this, oInfo);
        }
        else
        {

            final AlertDialog.Builder builder = new AlertDialog.Builder(MainActivity.this);
            builder.setNeutralButton(android.R.string.ok, new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface arg0, int arg1) {
                    //Cierra esta actividad

                }
            });
            builder.setCancelable(false);
            if(oInfo.isbNoEsElMomento())
            {
                builder.setTitle(R.string.NoWIFI);
            }
            else
            {
                builder.setTitle(R.string.NoDataToSynch);
            }

            builder.show();
        }

    }





private void lanzarBusqueda(View v)
{

    Intent i = new Intent(this, activity_Search.class);
    startActivity(i);

}




}



