package example.org.cuentanos;

import android.app.AlertDialog;
import android.content.Intent;
import android.location.Address;
import android.location.Criteria;
import android.location.Geocoder;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;

import java.io.IOException;
import java.util.List;
import java.util.Locale;

public class MapsActivity extends FragmentActivity implements OnMapReadyCallback , LocationListener,GoogleMap.OnMapClickListener, GoogleMap.OnMapLongClickListener
{
    private GoogleMap mMap;
    private LatLng miPosicion;
    private Location Auxlocalizacion;
//RELACIONADO CON LA POSICIÓN

    private static final long TIEMPO_MIN = 10 * 1000 ; // 10 segundos
    private static final long DISTANCIA_MIN = 5; // 5 metros
    private boolean  InicioProveedorPosción=false;
    private LocationManager manejador;
    private String proveedor;
    Criteria criterio;
    private Marker marker;
    private IncidenciaDataClass.Acciones accion= IncidenciaDataClass.Acciones.Nueva;



private String Direccion="";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Integer i;
        setContentView(R.layout.activity_maps);
        // Obtain the SupportMapFragment and get notified when the map is ready to be used.
        SupportMapFragment mapFragment = (SupportMapFragment) getSupportFragmentManager()
                .findFragmentById(R.id.map);

            Object Lat,Long;
            Lat=getIntent().getExtras().get("latitud");
            Long=getIntent().getExtras().get("longitud");
            i=getIntent().getExtras().getInt("ver");
            if(i==0)accion= IncidenciaDataClass.Acciones.Nueva;
            else accion= IncidenciaDataClass.Acciones.Ver;



            if((Lat!=null)&&(Long!=null))
            {
                miPosicion=new LatLng((Double)Lat,(Double)Long);
            }





        InicializaMapa();
        //if(miPosicion==null)
            incializaPosicion();

            EnlazaEventos();

    }




    private void InicializaMapa()
    {
        SupportMapFragment mapFragment = (SupportMapFragment) getSupportFragmentManager()
                .findFragmentById(R.id.map);
        mapFragment.getMapAsync(this);
        //mapFragment.getMapAsync(this);

    }


    private void EnlazaEventos() {
        //listener de nuevo
        Button bttAux;

        bttAux = (Button) findViewById(R.id.bttCancelarMaps);
        bttAux.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                ClickBotonCancel(null);
            }
        });


        if(accion== IncidenciaDataClass.Acciones.Nueva) {
            //listener de about
            bttAux = (Button) findViewById(R.id.bttAceptarMaps);
            bttAux.setOnClickListener(new View.OnClickListener() {
                public void onClick(View view) {
                    ClickBotonSave(null);
                }
            });
        }
        else {
            bttAux = (Button) findViewById(R.id.bttAceptarMaps);
            bttAux.setEnabled(false);
            TextView txtAux = (TextView) findViewById(R.id.Mapas);
            txtAux.setText(R.string.Visualizacion);

        }



    }

    //evento enlazado al boton
    private void ClickBotonCancel(View v)
    {
        Intent intent = new Intent();
        intent.putExtra("Position", "");
        setResult(RESULT_CANCELED, intent);
        finish();
    }
    //evento enlazado al boton
    private void ClickBotonSave(View v)
    {
        if(miPosicion!=null) {
            Intent intent = new Intent();
            intent.putExtra("Longitud", miPosicion.longitude);
            intent.putExtra("Latitud", miPosicion.latitude);
            intent.putExtra("Direccion", Direccion);
            setResult(RESULT_OK, intent);
            finish();
        }
        else
        {
            final CharSequence[] options = {
                    getResources().getText(R.string.Close)};
            final AlertDialog.Builder builder = new AlertDialog.Builder(MapsActivity.this);
            builder.setMessage(getResources().getText(R.string.SelectALocation));
            builder.show();
        }
    }


        @Override
    public void onMapReady(GoogleMap googleMap) {
        mMap = googleMap;
        mMap.setMyLocationEnabled(true);
        mMap.setMapType(GoogleMap.MAP_TYPE_NORMAL);
        mMap.setOnMapClickListener(this);
        mMap.setOnMapLongClickListener(this);

        if (miPosicion != null) {
            mMap.moveCamera(CameraUpdateFactory.newLatLngZoom(miPosicion, 15));
            if (!mMap.isMyLocationEnabled()) {
                mMap.setMyLocationEnabled(true);
            }
            AddMark(miPosicion);
        }
    }



    // Métodos del ciclo de vida de la actividad
    @Override protected void onResume() {
        super.onResume();
        if (accion == IncidenciaDataClass.Acciones.Nueva) {
            if (proveedor != null)
                manejador.requestLocationUpdates(proveedor, TIEMPO_MIN, DISTANCIA_MIN, this);
        }

    }
    @Override protected void onPause() {
        super.onPause();
        if (accion == IncidenciaDataClass.Acciones.Nueva) {
            if (manejador != null) {
                manejador.removeUpdates(this);
            }
        }
    }

    // Métodos de la interfaz LocationListener
    public void onLocationChanged(Location location) {
        Auxlocalizacion = location;
    }
    public void onProviderDisabled(String proveedor) {
                                             proveedor = manejador.getBestProvider(criterio, true);
        if (proveedor == null) {

            buildAlertMessageNoGps();

        }
    }
    public void onProviderEnabled(String proveedor) {
    }
    public void onStatusChanged(String proveedor, int estado, Bundle extras) {
    }



    private void incializaPosicion() {

        if(accion== IncidenciaDataClass.Acciones.Nueva) {
            manejador = (LocationManager) getSystemService(LOCATION_SERVICE);

            criterio = new Criteria();
            criterio.setCostAllowed(false);
            criterio.setAltitudeRequired(false);
            criterio.setAccuracy(Criteria.ACCURACY_FINE);
            proveedor = manejador.getBestProvider(criterio, true);


            if ((proveedor != null) && (miPosicion == null)) {
                Location localizacion;
            /*if(Auxlocalizacion==null)
            {
              localizacion = manejador.getLastKnownLocation(proveedor);
            }
            else
            {
              localizacion=Auxlocalizacion;
            }
            */
                localizacion = Auxlocalizacion;
                //si de la mejor no tiene última posición conocida busca de los demás proveedores
                if (localizacion == null) {
                    //busca la ultima posición de forma rápida
                    //por si el gps tarda mucho

                    List<String> proveedores = manejador.getAllProviders();
                    for (String proveedor : proveedores) {
                        localizacion = manejador.getLastKnownLocation(proveedor);
                        if (localizacion != null) {
                            miPosicion = new LatLng(localizacion.getLatitude(), localizacion.getLongitude());
                            break;
                        }
                    }
                } else {
                    miPosicion = new LatLng(localizacion.getLatitude(), localizacion.getLongitude());
                }
                //deja el mejor que haya
                AddMark(miPosicion);
            }
            proveedor = manejador.getBestProvider(criterio, true);
            if (proveedor == null) {

                buildAlertMessageNoGps();
            }
        }
        if((miPosicion!=null))
        {
            AddMark(miPosicion);

        }
    }


    private  void buildAlertMessageNoGps() {
        if(accion== IncidenciaDataClass.Acciones.Nueva) {
            final AlertDialog.Builder builder = new AlertDialog.Builder(this);
            builder.setMessage(getString(R.string.SelectALocation))
                    .setCancelable(true);

            final AlertDialog alert = builder.create();
            alert.show();
        }
    }


    //marca en el mapa una nueva posición
  private void AddMark(LatLng point)
    {

            if ((mMap != null) && (point != null)) {
                getCompleteAdress(point);
                if (marker != null)
                    marker.remove();

                String s = "----";
                if (Direccion.length() > 0) s = Direccion;

                marker = mMap.addMarker(new MarkerOptions()
                        .position(point)
                        .title(s)
                        .snippet(point.toString()));
                miPosicion = point;

            }

    }




    //eventos relacionados con click en pantalla

    @Override
    public void onMapClick(LatLng point) {
        mMap.animateCamera(CameraUpdateFactory.newLatLng(point));
    }

    @Override
    public void onMapLongClick(LatLng point) {
        if(accion== IncidenciaDataClass.Acciones.Nueva)
        AddMark(point);

    }


    public  void getCompleteAdress( LatLng position)
    {
        Direccion="";


        if(AppUtils.isConnectingToInternet(this)) {
            Geocoder geocoder = new Geocoder(this, Locale.getDefault());
            try {
                List<Address> addresses = geocoder.getFromLocation(position.latitude, position.longitude, 1);

                if (addresses != null) {
                    if(addresses.size()>0) {
                        Address returnedAddress = addresses.get(0);
                        StringBuilder strReturnedAddress = new StringBuilder();
                        for (int i = 0; i < returnedAddress.getMaxAddressLineIndex(); i++) {
                            strReturnedAddress.append(returnedAddress.getAddressLine(i)).append("");
                        }
                        Direccion = strReturnedAddress.toString();

                        String city = addresses.get(0).getLocality();

                        String country = addresses.get(0).getCountryName();
                        Direccion = Direccion + "," + city + "," + country;
                    }
                    else
                    {Direccion = "";}
                } else {
                    Direccion = "";
                }
            } catch (IOException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
                Direccion = "";
            }
        }
    }




}

