package example.org.cuentanos;

import android.app.ActivityManager;
import android.app.NotificationManager;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.os.IBinder;
import android.util.Log;

/**
 * Created by Jota on 13/11/2015.
 */
public class SynchService extends Service {
    private static final int ID_NOTIFICACION_CREAR = 1;
    private Intent ControlIntent;

    @Override
    public void onCreate() {
        Log.i("--SynchService_Cuentame", "---started");
    }


//cada vez que es lanzado intenta sincronizar
    @Override
    public int onStartCommand(Intent intenc, int flags, int idArranque) {
        InfoSync oInfo;
        oInfo=SynchManager.Synch(this);
        if(oInfo.isbOk()) {
            Notificacion.CreaciónNotificacion(this, oInfo);
        }

        return START_STICKY;
    }

    @Override public void onDestroy() {


        NotificationManager notificationManager = (NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);
        notificationManager.cancel(ID_NOTIFICACION_CREAR);

    }
    @Override public IBinder onBind(Intent intencion) {
        return null;
    }





//me permite controlar si el servicio está en marcha antes configurar las alarmas
    //asi evito lanzarlas cada vez desde el mail
public static boolean IsRunning(Context context)
{
    boolean bOk=false;
    ActivityManager manager = (ActivityManager)context.getSystemService(Context.ACTIVITY_SERVICE);//use context received in broadcastreceiver

    for (ActivityManager.RunningServiceInfo service : manager.getRunningServices(Integer.MAX_VALUE))
    {

        if (SynchService.class.getName().equals(service.service.getClassName())) {
            //running
            bOk=true;
        }


    }
    return bOk;

}


}