package example.org.cuentanos;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.content.res.Resources;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.preference.PreferenceManager;
import android.provider.MediaStore;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.TextView;

import java.io.File;

/**
 * Created by Jota on 05/11/2015.
 */
public class activity_incidencia extends Activity {

    private String APP_DIRECTORY = "";
    private String MEDIA_DIRECTORY = APP_DIRECTORY + "media";
    private String TEMPORAL_PICTURE_NAME = "temporal.jpg";
    private final int PHOTO_CODE = 100;
    private final int SELECT_PICTURE = 200;
    private final int SELECT_LOCATION = 300;

    private Integer categoria, subcategoria;
    private String PhotoPath="";
    private IncidenciaDataClass oIncidencia;
    private IncidenciaDataClass.Acciones oAccion;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_incidencia);

        //enlaza los eventos de los botones
        EnlazaEventos();

        //prepara el directorio de fotos
        PreparaDirectorioFotos();

        //prepara GPS Posición


        //dependiendo de si viene de una busqueda o de una nueva incidencia
        oAccion=RecogeDatos();

       switch (oAccion) {

           case Nueva:
               CreaIncidenciaVacia(categoria,subcategoria);
               break;


           case Ver:
                CargaDetalleIncidencia();
               break;

       }
        ConfiguraIU();
        //CargaIncidencia()
        MuestraIncidencia();
    }

    //enlaza los eventos de los botones
    private void EnlazaEventos() {
        //botón que lanza fotos
        Button button = (Button) findViewById(R.id.bttfoto);
        button.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                HacerFoto(null);
            }
        });

        //botón que lanza la imagen en splash
        button = (Button) findViewById(R.id.bttimagen);
        button.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                MostrarFoto(null);
            }
        });
        button.setVisibility(View.INVISIBLE);

        button = (Button) findViewById(R.id.bttAceptar);
        button.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                EnviarClick(null);
            }
        });

        button = (Button) findViewById(R.id.bttDireccion);
        button.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                LocalizacionClick(null);
            }
        });


        ImageButton ibutton = (ImageButton) findViewById(R.id.bttInfo);
        ibutton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                final AlertDialog.Builder builder = new AlertDialog.Builder(activity_incidencia.this);
                builder.setNeutralButton(android.R.string.ok, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface arg0, int arg1) {
                    }
                });
                builder.setCancelable(false);
                builder.setMessage(oIncidencia.GetInfo(getBaseContext()));


                builder.show();


            }
        });
    }

    //coge los datos de la actividad anterior
    //devuelve si viene de una busqueda
    private IncidenciaDataClass.Acciones RecogeDatos()
    {

        String aux;
        IncidenciaDataClass.Acciones oAccion=IncidenciaDataClass.Acciones.Nueva;

        categoria= Integer.parseInt(getIntent().getExtras().getString("_idCat"));
        subcategoria= Integer.parseInt(getIntent().getExtras().getString("_idSub"));


        aux= getIntent().getExtras().getString("nombreCat");
        TextView oText=(TextView)this.findViewById(R.id.Titulo);
        oText.setText("   " + aux);
        aux= getIntent().getExtras().getString("imagen");
        Resources res = this.getResources();
        oText.setCompoundDrawablesWithIntrinsicBounds(res.getIdentifier(aux, "drawable", this.getPackageName()), 0, 0, 0);

        aux= getIntent().getExtras().getString("nombreSub");
        oText=(TextView)this.findViewById(R.id.Titulo2);
        oText.setText(aux);


        oAccion= ((IncidenciaDataClass.Acciones)getIntent().getExtras().get("Accion"));
        if(oAccion== IncidenciaDataClass.Acciones.Ver)
        {

            oIncidencia=new IncidenciaDataClass();
            oIncidencia.set_id(Integer.parseInt(getIntent().getExtras().getString("_id")));
            oIncidencia.setCategoria(categoria);
            oIncidencia.setSubcategoria(subcategoria);
        }

        return oAccion;


    }

    //prepara los directorios
    private void PreparaDirectorioFotos()
    {
    PackageManager m = getPackageManager();
    String s = getPackageName();
    try {
        PackageInfo p = m.getPackageInfo(s, 0);
        s = p.applicationInfo.dataDir;
    } catch (PackageManager.NameNotFoundException e) {
        s="";
        Log.w("yourtag", "Error Package name not found ", e);

    }

    APP_DIRECTORY=s;
    MEDIA_DIRECTORY = APP_DIRECTORY + "/media";

}

    //lanza la captura de una imagen
    private void HacerFoto(View v)
    {

        final CharSequence[] options = {getResources().getText(R.string.TakeAPhoto),
                getResources().getText(R.string.SelectAPhoto),
                getResources().getText(R.string.Close)};
        final AlertDialog.Builder builder = new AlertDialog.Builder(activity_incidencia.this);
        builder.setTitle(getResources().getText(R.string.SelectOption));
        builder.setItems(options, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int seleccion) {
                if (options[seleccion] == getResources().getText(R.string.TakeAPhoto)) {
                    openCamera();
                } else if (options[seleccion] == getResources().getText(R.string.SelectAPhoto)) {
                    Intent intent = new Intent(Intent.ACTION_PICK, android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
                    intent.setType("image/*");
                    startActivityForResult(Intent.createChooser(intent, getResources().getText(R.string.SelectAnApp)), SELECT_PICTURE);
                } else if (options[seleccion] == getResources().getText(R.string.Close)) {
                    dialog.dismiss();
                }

            }
        });
        builder.show();
    }

    //abre la camara
    private void openCamera() {
        File file = new File(Environment.getExternalStorageDirectory(), MEDIA_DIRECTORY);
        file.mkdirs();
        TEMPORAL_PICTURE_NAME= AppUtils.FechaActualFile()+".jpg";

        String path = Environment.getExternalStorageDirectory() + File.separator
                + MEDIA_DIRECTORY + File.separator + TEMPORAL_PICTURE_NAME;

        File newFile = new File(path);

        Intent intent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
        intent.putExtra(MediaStore.EXTRA_OUTPUT, Uri.fromFile(newFile));
        startActivityForResult(intent, PHOTO_CODE);
    }

    //muestra la foto durante unos segundos
    private void MostrarFoto(View v)
    {

        Intent intent = new Intent(this, activity_PhotoSplash.class);
        intent.putExtra("pathPhoto",oIncidencia.getFoto());// PhotoPath);
        startActivity(intent);


    }

    //lanza el mapa
    private void LocalizacionClick(View v)
    {

        Intent intent = new Intent(this, MapsActivity.class);

        intent.putExtra("longitud", oIncidencia.getLongitud());
        intent.putExtra("latitud", oIncidencia.getLatitud());
        if(oAccion== IncidenciaDataClass.Acciones.Ver)
        {
            intent.putExtra("ver", 1);
        }
        else
        {
            intent.putExtra("ver", 0);
        }

        startActivityForResult(intent, SELECT_LOCATION);
    }


    //resultado de la foto o del mapa
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if(oAccion== IncidenciaDataClass.Acciones.Nueva) {
            switch (requestCode) {
                case PHOTO_CODE:
                    if (resultCode == RESULT_OK) {
                        PhotoPath = Environment.getExternalStorageDirectory() + File.separator
                                + MEDIA_DIRECTORY + File.separator + TEMPORAL_PICTURE_NAME;
                        oIncidencia.setFoto(PhotoPath);
                    }
                    break;

                case SELECT_PICTURE:
                    if (resultCode == RESULT_OK) {
                        Uri path = data.getData();
                        PhotoPath = AppUtils.getRealPathFromURI(path, this.getApplicationContext());
                        oIncidencia.setFoto(PhotoPath);
                    }
                    break;
                case SELECT_LOCATION:

                    if (resultCode == RESULT_OK) {
                        Double res = data.getExtras().getDouble("Latitud");
                        oIncidencia.setLatitud(res);
                        res = data.getExtras().getDouble(("Longitud"));
                        oIncidencia.setLongitud(res);

                        String Dire = data.getExtras().getString("Direccion");
                        oIncidencia.setDireccion(Dire);

                        TextView oTextView = (TextView) findViewById(R.id.Direccion);
                        oTextView.setText(oIncidencia.TextoDirección());
                    }
                    break;


            }

            if (PhotoPath.length() > 0) {
                Button button = (Button) findViewById(R.id.bttimagen);
                button.setVisibility(View.VISIBLE);

            }
        }
    }




    /*----------------------------------------------------------------------------------*/
    //respecto a los objetos

    //crea una incidencia en blanco
    private void CreaIncidenciaVacia(Integer categoria, Integer subcategoria)
    {
        SharedPreferences pref;
        pref = PreferenceManager. getDefaultSharedPreferences(this.getBaseContext());

        oIncidencia=new IncidenciaDataClass();
        oIncidencia.setCategoria(categoria);
        oIncidencia.setSubcategoria(subcategoria);
        oIncidencia.setNombre(pref.getString("nombre", ""));
        oIncidencia.setDni(pref.getString("dni", ""));
        oIncidencia.setEmail(pref.getString("mail", ""));


        EditText e=(EditText)findViewById(R.id.txTelefono);


            oIncidencia.setTelefono(pref.getString("phone", ""));
            e.setEnabled(true);


    }


    //muestra incidencia
    private void  MuestraIncidencia()
    {

      //estos están siempre, sea con un nuevo o con una busqueda
      TextView txtAux= (TextView) findViewById(R.id.txtNombre);
      txtAux.setText(oIncidencia.getNombre());
      txtAux= (TextView) findViewById(R.id.txtDni);
      txtAux.setText(oIncidencia.getDni());
      txtAux= (TextView) findViewById(R.id.txTelefono);
      txtAux.setText(oIncidencia.getTelefono());
      txtAux= (TextView) findViewById(R.id.txtEmail);
      txtAux.setText(oIncidencia.getEmail());

    //falta la parte de si viene de una busqueda
        txtAux= (TextView) findViewById(R.id.txtComentario);
        txtAux.setText(oIncidencia.getObservacion());
        txtAux= (TextView) findViewById(R.id.Direccion);
        txtAux.setText(oIncidencia.getDireccion());

  }


    //en función de cómo es la acción configura de una forma u otra el IU
    private void ConfiguraIU()
    {
        Button button;
        EditText oTetxv;
        switch (oAccion)
        {
            case Nueva:

                oTetxv = (EditText) findViewById(R.id.txtNombre);
                oTetxv.setEnabled(true);
                oTetxv = (EditText) findViewById(R.id.txtEmail);
                oTetxv.setEnabled(true);
                oTetxv = (EditText) findViewById(R.id.txtDni);
                oTetxv.setEnabled(true);
                oTetxv = (EditText) findViewById(R.id.txTelefono);
                oTetxv.setEnabled(true);
                oTetxv = (EditText) findViewById(R.id.txtComentario);
                oTetxv.setEnabled(true);

                button = (Button) findViewById(R.id.bttimagen);
                button.setVisibility(View.INVISIBLE);
                button = (Button) findViewById(R.id.bttfoto);
                button.setEnabled(true);
                button = (Button) findViewById(R.id.bttDireccion);
                button.setText(getResources().getText(R.string.TakePosition));
                button.setEnabled(true);
                button = (Button) findViewById(R.id.bttAceptar);
                button.setEnabled(true);
                button.setText(getResources().getText(R.string.Save));
                button.setVisibility(View.VISIBLE);
                ImageButton ibutton = (ImageButton) findViewById(R.id.bttInfo);
                ibutton.setVisibility(View.INVISIBLE);
                break;

            case Ver:

                oTetxv = (EditText) findViewById(R.id.txtNombre);
                oTetxv.setEnabled(false);
                oTetxv = (EditText) findViewById(R.id.txtEmail);
                oTetxv.setEnabled(false);
                oTetxv = (EditText) findViewById(R.id.txtDni);
                oTetxv.setEnabled(false);
                oTetxv = (EditText) findViewById(R.id.txTelefono);
                oTetxv.setEnabled(false);
                oTetxv = (EditText) findViewById(R.id.txtComentario);
                oTetxv.setEnabled(false);


                button = (Button) findViewById(R.id.bttimagen);
                button.setEnabled(true);
                button.setVisibility(View.VISIBLE);

                button = (Button) findViewById(R.id.bttfoto);
                button.setEnabled(false);

                button = (Button) findViewById(R.id.bttDireccion);
                button.setEnabled(true);

                button = (Button) findViewById(R.id.bttAceptar);
                button.setVisibility(View.INVISIBLE);
                button = (Button) findViewById(R.id.bttDireccion);
                button.setText(getResources().getText(R.string.SeePosition));

                 ibutton = (ImageButton) findViewById(R.id.bttInfo);
                ibutton.setVisibility(View.VISIBLE);
                break;
        }

    }

    //evento producido cuando se hace click sobre el botón de enviar
    private void EnviarClick(View v)
    {
        EditText oTetxv;
        oTetxv = (EditText) findViewById(R.id.txtNombre);
        oIncidencia.setNombre(oTetxv.getText().toString());

        oTetxv = (EditText) findViewById(R.id.txtEmail);
        oIncidencia.setEmail(oTetxv.getText().toString());

        oTetxv = (EditText) findViewById(R.id.txtDni);
        oIncidencia.setDni(oTetxv.getText().toString());

        oTetxv = (EditText) findViewById(R.id.txTelefono);
        oIncidencia.setTelefono(oTetxv.getText().toString());

        oTetxv = (EditText) findViewById(R.id.txtComentario);
        oIncidencia.setObservacion(oTetxv.getText().toString());
        final CharSequence[] options = {
                getResources().getText(R.string.Close)};
        final AlertDialog.Builder builder = new AlertDialog.Builder(activity_incidencia.this);


        if(oIncidencia.Valida())
        {
            db_DataAcces odb_DataAcces=new db_DataAcces();
            odb_DataAcces.indicializaBD(this);
            if(odb_DataAcces.GuardaIncidencia(oIncidencia))
            {
                builder.setMessage(R.string.GuardadoOk);
                builder.setNeutralButton(android.R.string.ok, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface arg0, int arg1) {
                        //vuelve a el principal
                        Intent mainIntent = new Intent().setClass(activity_incidencia.this, MainActivity.class);
                        startActivity(mainIntent);
                        //Cierra esta actividad

                        finish();
                    }
                });
                builder.setCancelable(false);
            }
            else
            {
                builder.setMessage(R.string.ErrorApp);
                builder.setCancelable(false);
                builder.setNeutralButton(android.R.string.ok, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface arg0, int arg1) {
                        //Cierra esta actividad

                    }
                });

            }
        }
        else
        {
            builder.setMessage(oIncidencia.ErrorMsg(this));
            builder.setCancelable(false);
            builder.setNeutralButton(android.R.string.ok, new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface arg0, int arg1) {
                    //vuelve a el principal

                }
            });

        }
        builder.show();
    }




    //carga el detalle de una incidencia
    private void CargaDetalleIncidencia()
    {
        Integer Counter=0;
        Cursor ocursor;
        db_DataAcces odb_DataAcces=new db_DataAcces();
        odb_DataAcces.indicializaBD(this);
        ocursor=odb_DataAcces.getIncidenciaByID(oIncidencia.get_id());

        while(ocursor.moveToNext()) {


            oIncidencia =
                    new IncidenciaDataClass(ocursor.getInt(0),//i._id
                            ocursor.getInt(1),//categoria
                            ocursor.getInt(2),//subcategoria
                            ocursor.getInt(3),//procesado
                            ocursor.getString(4),//TicketCentral
                            ocursor.getString(5),//dni
                            ocursor.getString(6),//Nombre
                            ocursor.getString(7),//email
                            ocursor.getString(8),//observacion
                            ocursor.getString(9),//direccion
                            ocursor.getDouble(10),//longitud
                            ocursor.getDouble(11),//latitud
                            ocursor.getString(12),//foto
                            ocursor.getString(13),//telefono
                            ocursor.getString(14),//fecha
                            ocursor.getInt(15));//enviado
        }



    }


}




