package example.org.cuentanos;

import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;

/**
 * Created by Jota on 04/11/2015.
 */
public class db_DataAcces {
    private  db_incidenciasSQLLite incidenciasBD;
    private  SQLiteDatabase bd;

    public  void indicializaBD(Context contexto) {
        incidenciasBD = new db_incidenciasSQLLite(contexto);
    }

    public  Cursor getlistadoCategorias() {
        bd = incidenciasBD.getReadableDatabase();
        String displayLanguage = AppUtils.GetLanguage();

        String select = " _id, nombre_" + displayLanguage + " as nombre,imagen ";

        return bd.rawQuery("SELECT " + select + " FROM categorias", null);
    }

    public  Cursor getlistadoSubCategorias(Integer i) {
        bd = incidenciasBD.getReadableDatabase();
        String displayLanguage = AppUtils.GetLanguage();
        String select = " _id, nombre_" + displayLanguage + " as nombre,_idCat ";

        return bd.rawQuery("SELECT " + select + " FROM subcategorias where _idCat=" + i.toString(), null);
    }

    //guarda una incidencia en la tabla correspondiente
    public  boolean GuardaIncidencia(IncidenciaDataClass pInciencia) {
        bd = incidenciasBD.getWritableDatabase();
        boolean bOk;
        try {
            bd.execSQL(pInciencia.GetInsertCommand());
            bd.close();
            bOk = true;
        } catch (SQLException e) {
            bOk = false;
        }

        return bOk;
    }

    //obtiene el listado de incidencias sin enviar-->para enviar
    //obtenie el listado de incidencias enviadas-->para buscar
    public  Cursor getlistadoIncidencias() {
        bd = incidenciasBD.getReadableDatabase();

        return bd.rawQuery(IncidenciaDataClass.GetListadoIncidenciasCommand(), null);
    }


    //obtiene el listado de incidencias sin enviar-->para enviar
    //obtenie el listado de incidencias enviadas-->para buscar
    public  Cursor getlistadoIncidencias(boolean bEnviada, boolean bProcesado) {
        bd = incidenciasBD.getReadableDatabase();

        return bd.rawQuery(IncidenciaDataClass.GetListadoIncidenciasCommand(bEnviada,bProcesado), null);
    }

    //permite actualizar una incidencia como enviada
    public  boolean CambiaEnviadoIncidencia(IncidenciaDataClass oIncidencia)
    {

        bd = incidenciasBD.getWritableDatabase();
        boolean bOk;
        try {
            bd.execSQL(oIncidencia.GetEnviadoUpdatedCommand());
            bd.close();
            bOk = true;
        } catch (SQLException e) {
            bOk = false;
        }

        return bOk;
    }


    //obtenie una incicencia para mostrar
    public  Cursor getIncidenciaByID(Integer i) {
        bd = incidenciasBD.getReadableDatabase();

        return bd.rawQuery(IncidenciaDataClass.GetIncidenciabyIDCommand(i), null);
    }

    //permite actualizar una incidencia con un codigo de ticket centralizado-->pasa a ser procesada
    public  boolean CambiaProcesadoIncidencia(IncidenciaDataClass oIncidencia)
    {

        bd = incidenciasBD.getWritableDatabase();
        boolean bOk;
        try {
            bd.execSQL(oIncidencia.GetProcesadoUpdatedCommand());
            bd.close();
            bOk = true;
        } catch (SQLException e) {
            bOk = false;
        }

        return bOk;
    }

public void CierraBBDD()
{
    if(bd!=null)
        bd.close();
}
}
