package example.org.cuentanos;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

/**
 * Created by Jota on 04/11/2015.
 */

public class db_incidenciasSQLLite extends SQLiteOpenHelper
{
    public db_incidenciasSQLLite(Context context) {
        super(context, "indicencias", null, 4);
    }



    //Métodos de SQLiteOpenHelper
    //crea la base de datos por primera vez
    @Override public void onCreate(SQLiteDatabase db) {

        try {
            db.execSQL("CREATE TABLE categorias (_id INTEGER PRIMARY KEY , nombre_es TEXT,nombre_en TEXT, imagen TEXT)");

            //subcaterias
            db.execSQL("CREATE TABLE subcategorias(" +
                    "_id INTEGER PRIMARY KEY , " +
                    "_idCat INTEGER , " +
                    "nombre_es TEXT , " +
                    " nombre_en TEXT)");

            //incidencias
            db.execSQL("CREATE TABLE incidencias (" +
                    "_id INTEGER PRIMARY KEY AUTOINCREMENT, " +
                    "categoria integer, " +
                    "subcategoria integer, " +
                    "dni TEXT, " +
                    "Nombre TEXT, " +
                    "email TEXT, " +
                    "observacion TEXT, " +
                    "direccion TEXT, " +
                    "longitud REAL, " +
                    "latitud REAL, " +
                    "foto TEXT, " +
                    "telefono TEXT, " +
                    "fecha DATETIME," +
                    "enviado INTEGER," +
                    "ticketCental TEXT," +
                    "procesado INTEGER)");
            inicializaDatos_categorias(db);
            inicializaDatos_subcategorias(db);

        }
        catch (Exception e)
        {
            String s= e.toString();
            Log.d("db_incidenciasSQLLite", "onCreate() returned: " + s);
        }
        finally {

        }
        //categorias


    }

    //mete los datos iniciales en la base de datos
    //debería cargarse desde un xml, no por código
    private void inicializaDatos_categorias(SQLiteDatabase bd)
    {
        bd.execSQL("INSERT INTO categorias " +
                "VALUES " +
                "(1, 'Basuras','Garbage', 'garbage')");

        bd.execSQL("INSERT INTO categorias " +
                "VALUES " +
                "(2,  'Calles','Streets', 'highway')");

        bd.execSQL("INSERT INTO categorias " +
                "VALUES " +
                "(3,  'Luces','Light', 'light')");

        bd.execSQL("INSERT INTO categorias " +
                "VALUES " +
                "(4,  'Parques','Parks', 'park')");

        bd.execSQL("INSERT INTO categorias " +
                "VALUES " +
                "(5,  'Playas','Beach', 'swimming')");
    }


    private void inicializaDatos_subcategorias(SQLiteDatabase bd)
    {
        //basuras
        bd.execSQL("INSERT INTO subcategorias " +
                "VALUES " +
                "(1, "+
                "1, " +
                "'Mejora de la limpieza','Improved cleaning')");

        bd.execSQL("INSERT INTO subcategorias " +
                "VALUES " +
                "(2, "+
                "1, " +
                "'Reparación de un contenedor','Repairing a container')");

        bd.execSQL("INSERT INTO subcategorias " +
                "VALUES " +
                "(3, "+
                "1, " +
                "'Reparación de una papelera','Repair a paper bin')");

        bd.execSQL("INSERT INTO subcategorias " +
                "VALUES " +
                "(4, "+
                "1, " +
                "'Otros','Others')");

        //Calles
        bd.execSQL("INSERT INTO subcategorias " +
                "VALUES " +
                "(5, "+
                "2, " +
                "'Reparación de aceras','Repair sidewalks ')");

        bd.execSQL("INSERT INTO subcategorias " +
                "VALUES " +
                "(6, "+
                "2, " +
                "'Reparación de calzadas','Repair of roads')");

        bd.execSQL("INSERT INTO subcategorias " +
                "VALUES " +
                "(7, "+
                "2, " +
                "'Arquetas y canalizaciones','Manholes and pipes')");

        bd.execSQL("INSERT INTO subcategorias " +
                "VALUES " +
                "(8, "+
                "2, " +
                "'Otros','Others')");

    //luces
        bd.execSQL("INSERT INTO subcategorias " +
                "VALUES " +
                "(9, "+
                "3, " +
                "'Aumento del Nivel de Iluminación','Lighting Level Rise')");

        bd.execSQL("INSERT INTO subcategorias " +
                "VALUES " +
                "(10, "+
                "3, " +
                "'Reparación de un punto de luz','Repairing a point of light')");

        bd.execSQL("INSERT INTO subcategorias " +
                "VALUES " +
                "(11, "+
                "3, " +
                "'Otros','Others')");

        //parques
        bd.execSQL("INSERT INTO subcategorias " +
                "VALUES " +
                "(12, "+
                "4, " +
                "'Mantenimiento general','General maintenance')");

        //playas
        bd.execSQL("INSERT INTO subcategorias " +
                "VALUES " +
                "(13, "+
                "5, " +
                "'Vertidos en el mar','Dumping at sea')");

        bd.execSQL("INSERT INTO subcategorias " +
                "VALUES " +
                "(14, "+
                "5, " +
                "'Otros','Others')");


    }


    @Override public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
// En caso de una nueva versión habría que actualizar las tablas
    }





}